var request = require('request');



module.exports  = function(config){

    var requester = {};

    requester.list = function () {

        var promise = new Promise(function (resolve, reject) {

            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/chattrees",
            }, function (err, httpResponse, body) {

                if (!err) {

                    console.log("######################");
                    //console.log(body);
                    resolve(JSON.parse(body));
                } else {
                    console.log("erro ao listar dados", err);
                    reject(err);
                }

            })

        });


        return promise;
    }


    requester.listCompanies = function () {

        var promise = new Promise(function (resolve, reject) {


            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/companies",
            }, function (err, httpResponse, body) {

                if (!err) {
                    resolve(JSON.parse(body));
                } else {
                    console.log("erro ao listar dados", err);
                    reject(err);
                }

            })

        });


        return promise;
    }


    requester.findCompany = function (id) {

        var promise = new Promise(function (resolve, reject) {

            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/companies/"+id,
            }, function (err, httpResponse, body) {

                if (!err) {
                    resolve(JSON.parse(body));
                } else {
                    console.log("erro ao listar dados", err);
                    reject(err);
                }

            })

        });


        return promise;
    }


    requester.findTree = function (id) {

        var promise = new Promise(function (resolve, reject) {

            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/chattrees/"+id,
                json: true,
            }, function (err, httpResponse, body) {

                if (!err) {

                    try{
                        resolve(body);
                    }catch (e){
                        console.log(e);
                        reject(e);
                    }


                } else {
                    console.log("erro ao listar dados", err);
                    reject(err);
                }

            })

        });


        return promise;
    }


    requester.findTreeByCompanyId = function (treeId) {

        var promise = new Promise(function (resolve, reject) {

            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/chattrees/"+treeId+"/findByCompanyId",
            }, function (err, httpResponse, body) {

                if (!err) {
                    resolve(JSON.parse(body));
                } else {
                    console.log("erro ao listar dados", err);
                    reject(err);
                }

            })

        });


        return promise;
    }


    requester.listKeywordsExpressions = function () {

        return new Promise(function (resolve, reject) {
            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/keywordintents",
                json: true,
            }, function (err, httpResponse, body) {

                if (!err) {

                    try {
                        resolve(body);
                    } catch (e) {
                        console.log(e);
                        reject(e);
                    }

                } else {
                    console.log("erro ao listar dados", err);
                    reject(err);
                }

            })

        });

    }



        return requester;


};




